;=======================================================================
;			    
;						    FORD.
;=======================================================================
;			  :
;			 - PIC12F629
;=======================================================================
;			  :
;		GP (7)	-      .
;		GP1 (6)	-    .
;		GP2 (5)	-    .
;		GP3 (4)	-    .
;		GP4 (3)	-    .
;		GP5 (2)	-   .
;=======================================================================
			list      p=12F629
			#include <p12F629.inc>
	__CONFIG _CP_OFF&_WDT_OFF&_PWRTE_ON&_INTRC_OSC_NOCLKOUT&_MCLRE_OFF
;=======================================================================
;								.
;=======================================================================
K				EQU		0x20
L				EQU		0x21
M				EQU		0x22
N				EQU		0x23
cnt1			EQU		0x2A
cnt2			EQU		0x2B
cnt3			EQU		0x2C
;=======================================================================
	ORG		0x00
	goto	Start
;=======================================================================
;							 .
;=======================================================================
Start
;-----------------------------------------------------------------------
;								.
;-----------------------------------------------------------------------
	clrwdt					;  WDT  .
	bcf		STATUS, RP0		; bank 0
	clrf	GPIO			;   GPIO.
	movlw	7
	movwf	CMCON			;  GPIO -  /.
	bsf		STATUS, RP0		; bank 1
	movlw	b'10001111'		; 
	movwf	OPTION_REG		; 
	movlw	0x18			; b'00011000'
	movwf	TRISIO			; GP4,GP3 - , GP5,GP2-GP0 - .
	call	3FFh			;   .
	movwf	OSCCAL
	bcf		STATUS, RP0		; bank 0
;-----------------------------------------------------------------------
	call	ONESHOT
	bsf		GPIO, 5			;  .
	bsf		GPIO, 1			;   .
	call	Delay_1.0
	call	Delay_1.0
	call	Delay_1.0
	bcf		GPIO, 1			;   .
	bcf		GPIO, 5			;  .
;=======================================================================
Main
	call	KEY
	goto	Main
;=======================================================================
KEY
	btfsc	GPIO, 4			;    .
	call	Impuls			;     .
	btfsc	GPIO, 3			;    .
	call	Automat			;     .
	return
;=======================================================================
Automat
	bsf		GPIO, 5			;  .
	bsf		GPIO, 2			;   .
	call	Delay_1.0
	call	Delay_0.6
	bsf		GPIO, 1			;   .
	call	Delay_1.0
	call	Delay_1.0
	call	Delay_0.6
	bcf		GPIO, 2			;   .
	call	Delay_1.0
	call	Delay_1.0
	call	Delay_1.0
;	call	Delay_1.0
	bcf		GPIO, 1			;   .
	bcf		GPIO, 5			;  .
	return
;=======================================================================
Impuls	
	bsf		GPIO, 5			;  .
	bsf		GPIO, 1			;   .
	call	Delay_0.6
;	call	Delay_1.0
	bcf		GPIO, 1			;   .
	bcf		GPIO, 5			;  .
	call	ONESHOT
	return
;=======================================================================
;				    .
;=======================================================================
ONESHOT
	movlw	1
	movwf	K
	movwf	L
	movwf	M
	movwf	N
	bsf		STATUS, RP0
	bsf		GPIO, 0			;   GP0  .
	bcf		STATUS, RP0
;-----------------------------------------------------------------------
TST							;   .
	clrwdt
	btfsc	GPIO, 3			;    .
	call	Automat			;     .
	btfss	GPIO, 0			;      
	goto	READY			;       ,
	incfsz	K, f			;  K   .
	goto	TST
	incfsz	L, f			;  L   .
	goto	TST
	incfsz	M, f			;  M   .
	goto	TST
	incfsz	N, f			;  N   .
	goto	TST
;-----------------------------------------------------------------------
READY
	bsf		STATUS, RP0
	bcf		GPIO, 0			;   GP0  ,
	bcf		STATUS, RP0
	bsf		GPIO, 0			;    ,  
							; .
	return
;=======================================================================
;							 - 0.6 .
;=======================================================================
Delay_0.6
	movlw   .20
	movwf   cnt3
loop3
	movlw   .100
	movwf   cnt2
loop2 
	movlw   .100
	movwf   cnt1
	clrwdt				;   .
loop1
	decfsz  cnt1, f
	goto	loop1
	decfsz  cnt2, f
	goto	loop2
	decfsz  cnt3, f
	goto	loop3
	return
;=======================================================================
;							 - 1.0 .
;=======================================================================
Delay_1.0
	movlw   .33
	movwf   cnt3
loop_3
	movlw   .100
	movwf   cnt2
loop_2 
	movlw   .100
	movwf   cnt1
	clrwdt				;   .
loop_1
	decfsz  cnt1, f
	goto	loop_1
	decfsz  cnt2, f
	goto	loop_2
	decfsz  cnt3, f
	goto	loop_3
	return
;=======================================================================
	END
